app/urls.py
"""
URL Configuration
"""
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from qa.views import IndexView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('api/', include('api.urls')),
    path('qa/', include('qa.urls')),
    path('', IndexView.as_view(), name="index"),
]

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

qa/urls.py
from django.urls import path

from . import views

app_name = 'qa'
urlpatterns = [
    path('ask', views.ask_view, name='ask'),
    path('<int:question_id>/', views.QuestionView.as_view(), name='question'),
    path('<int:question_id>/vote/', views.vote, name='vote'),
    path('answer/<int:answer_id>/vote/', views.vote_answer, name='vote_answer'),
    path('answer/<int:answer_id>/', views.correct_answer, name='correct_answer'),
    path('', views.SearchView.as_view(), name='search')
]

qa/models.py
from django.contrib.auth.models import User
from django.contrib.contenttypes.fields import GenericRelation
from django.db import models
from django.utils import timezone


class Tag(models.Model):
    name = models.CharField('Имя тега', max_length=255)

    def __str__(self):
        return self.name


class AutoDateTimeField(models.DateTimeField):
    def pre_save(self, model_instance, add):
        return timezone.now()


class Question(models.Model):
    title = models.CharField('Заголовок вопроса', max_length=255)
    text = models.TextField('Текст вопроса')

    user = models.ForeignKey(User, on_delete=models.CASCADE)
    created = models.DateTimeField('Дата создания', default=timezone.now)
    updated = AutoDateTimeField('Дата обновления')

    votes = GenericRelation('VoteQuestion')
    score = models.IntegerField(default=0)
    is_answered = models.BooleanField('Ответ получен', default=False)

    tags = models.ManyToManyField(Tag)

    def __str__(self):
        return self.title

    def vote(self, user, value):
        obj = VoteQuestion.objects.filter(question=self, user=user).first()
        if obj:
            self.score -= obj.value
            obj.value = value
            obj.save()
        else:
            VoteQuestion(user=user, value=value, question=self).save()
        self.score += value
        self.save()
        return self.score


class Answer(models.Model):
    text = models.TextField('Текст ответа')
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    created = models.DateTimeField('Дата ответа', default=timezone.now)

    votes = GenericRelation('VoteAnswer')
    score = models.IntegerField(default=0)
    is_answered = models.BooleanField('Является ответом', default=False)

    def __str__(self):
        return self.text

    def vote(self, user, value):
        obj = VoteAnswer.objects.filter(answer=self, user=user).first()
        if obj:
            self.score -= obj.value
            obj.value = value
            obj.save()
        else:
            VoteAnswer(user=user, value=value, answer=self).save()
        self.score += value
        self.save()
        return self.score


class VoteQuestion(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    value = models.IntegerField(default=0)
    question = models.ForeignKey(Question, on_delete=models.CASCADE)


class VoteAnswer(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    value = models.IntegerField(default=0)
    answer = models.ForeignKey(Answer, on_delete=models.CASCADE)

qa/forms.py
from django import forms

from qa.models import Question, Answer


class QuestionForm(forms.ModelForm):
    tags = forms.CharField(required=False)

    class Meta:
        model = Question
        fields = ["title", "text", "tags"]


class AnswerForm(forms.ModelForm):
    class Meta:
        model = Answer
        fields = ["text"]


class SearchForm(forms.Form):
    search = forms.CharField()

qa/views.py
import json
from json import JSONDecodeError

from django.contrib import messages
from django.core.mail import send_mail
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from django.db.models import Q
from django.http import HttpResponseRedirect, JsonResponse
from django.shortcuts import render, get_object_or_404, get_list_or_404, \
    redirect
from django.urls import reverse
from django.views.decorators.http import require_POST
from django.views.generic.base import TemplateView

from qa.models import Question, Answer, Tag
from qa.forms import QuestionForm, AnswerForm


def ask_view(request):
    if request.method == "POST":
        form = QuestionForm(request.POST)
        if form.is_valid():
            question = form.save(commit=False)
            question.user = request.user
            tags = form.cleaned_data.get('tags', []).split(',')
            tag_objs = []
            if len(tags) <= 3:
                for tag in tags:
                    obj, _ = Tag.objects.get_or_create(name=tag.strip())
                    tag_objs.append(obj)
                question.save()
                question.tags.set(tag_objs)
                question.save()
                messages.success(request, 'Вопрос успешно создан')
                return HttpResponseRedirect(reverse('qa:question',
                                                    args=(question.id,)))
            else:
                messages.error(request, 'Допускается не более 3 тегов')
                form.add_error('tags', 'Допускается не более 3 тегов')
        else:
            messages.error(request, 'Не удалось создать вопрос')
    else:
        form = QuestionForm()

    form.fields['tags'].label = 'Список тегов (через запятую)'
    return render(request=request,
                  template_name="qa/ask.html",
                  context={"form": form})


def process_paginator(self, paginator):
    page = self.request.GET.get("page")
    try:
        show_lines = paginator.page(page)
    except PageNotAnInteger:
        show_lines = paginator.page(1)
    except EmptyPage:
        show_lines = paginator.page(paginator.num_pages)
    return show_lines


class QuestionView(TemplateView):
    model = Question
    template_name = "qa/question.html"

    def get_context_data(self, question_id, **kwargs):
        context = super().get_context_data(**kwargs)
        question = get_object_or_404(Question, pk=question_id)
        answers = question.answer_set.order_by('-is_answered',
                                               '-score', '-created')
        context['question'] = question
        context['form'] = AnswerForm()
        context['answers'] = answers

        paginator = Paginator(answers, 30)
        context["lines"] = process_paginator(self, paginator)
        return context

    def post(self, request, *args, question_id, **kwargs):
        form = AnswerForm(request.POST)
        if form.is_valid():
            answer = form.save(commit=False)
            answer.user = request.user
            answer.question = get_object_or_404(Question, pk=question_id)
            answer.save()
            self.notify_user(answer)
            return HttpResponseRedirect(reverse('qa:question',
                                                args=(question_id,)))
        else:
            context = self.get_context_data()
            return self.render_to_response(context)

    @staticmethod
    def notify_user(answer):
        subject = "Ответ на вопрос"
        message = "Кто-то ответил на вопрос"
        send_mail(subject, message, None, [answer.question.user.email])


class IndexView(TemplateView):
    model = Question
    template_name = 'qa/index.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        questions = Question.objects.order_by('-created', '-score')
        context['questions'] = questions

        paginator = Paginator(questions, 20)
        context["lines"] = process_paginator(self, paginator)
        return context


class SearchView(TemplateView):
    model = Question
    template_name = 'qa/search.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        questions = []
        search = self.request.GET.get('search')
        if search:
            if search.startswith('tag:'):
                tag = search.split(':')[1]
                questions = Question.objects.\
                    order_by('-score', '-created').\
                    filter(Q(tags__name=tag))
            else:
                questions = Question.objects.\
                    order_by('-score', '-created'). \
                    filter(
                        Q(text__icontains=search) |
                        Q(title__icontains=search)
                    )
        context['questions'] = questions

        paginator = Paginator(questions, 20)
        context["lines"] = process_paginator(self, paginator)
        return context


def parse_request(request):
    data = {}
    try:
        data = json.loads(request.body)
    except JSONDecodeError:
        pass
    return data


@require_POST
def vote(request, question_id):
    data = parse_request(request)
    question = Question.objects.get(pk=question_id)
    score = question.vote(request.user, int(data['vote']))
    return JsonResponse({'score': score})


@require_POST
def vote_answer(request, answer_id):
    data = parse_request(request)
    answer = Answer.objects.get(pk=answer_id)
    score = answer.vote(request.user, int(data['vote']))
    return JsonResponse({'score': score})


def trending(request):
    return {'trending': Question.objects.order_by('-score')[:10]}


def correct_answer(request, answer_id):
    answer = get_object_or_404(Answer, pk=answer_id)
    question = answer.question
    if not question.is_answered and question.user == request.user:
        answer.is_answered = True
        answer.save()
        question.is_answered = True
        question.save()
    else:
        messages.error(request, 'Не удалось отметить ответ как верный')
    return redirect('qa:question', answer.question.id)

templates/qa/ask.html
{% extends 'base.html' %}
{% load bootstrap5 %}

{% block title %}Задать вопрос{% endblock %}'

{% block content %}
    <div class="container py-2">
      {% if user.is_authenticated %}
      <form method="POST">
        {% csrf_token %}
        {% bootstrap_form form %}
        <button class="btn btn-primary" type="submit">Создать</button>
      </form>
      {% else %}
        <svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
          <symbol id="info-fill" fill="currentColor" viewBox="0 0 16 16">
            <path d="M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zm.93-9.412-1 4.705c-.07.34.029.533.304.533.194 0 .487-.07.686-.246l-.088.416c-.287.346-.92.598-1.465.598-.703 0-1.002-.422-.808-1.319l.738-3.468c.064-.293.006-.399-.287-.47l-.451-.081.082-.381 2.29-.287zM8 5.5a1 1 0 1 1 0-2 1 1 0 0 1 0 2z"/>
          </symbol>
        </svg>
        <div class="alert alert-warning alert-dismissible fade show" role="alert">
            <svg class="bi flex-shrink-0 me-2" width="24" height="24" role="img" aria-label="Info:"><use xlink:href="#info-fill"/></svg>
            Чтобы задать вопрос, выполните <a href="/user/login">вход</a>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
      {% endif %}
    </div>
{% endblock %}

templates/qa/index.html
{% extends 'base.html' %}
{% load bootstrap5 %}

{% block title %}
    Новые вопросы
{% endblock %}'

{% block content %}
    {% if lines %}
        {% for question in lines %}
            <div class="d-flex py-3">
                <div class="card d-flex flex-column w-100">
                    <div class="card-header{% if question.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                        <div class="row">
                            <div class="col">
                                <span class="fs-7"><span class="badge bg-secondary rounded-pill">{{ question.user }}</span></span>
                            </div>
                            <div class="col text-end">
                                <small class="fs-7">Создан:  <span class="badge bg-secondary rounded-pill">{{ question.created }}</span></small>
                            </div>
                        </div>
                    </div>
                    <div class="card-body d-flex">
                        <div class="d-flex flex-column w-100">
                            <a href="{% url 'qa:question' question_id=question.id %}" class="fs-5">
                                {{ question.title }}
                            </a>
                            {% if question.is_answered %}(для этого вопроса указано решение){% endif %}
                        </div>
                        <div class="d-flex flex-column text-center" style="width: 120px">
                            <b class="fs-3">{{ question.score }}</b>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
    {% endif %}
    {% if lines.paginator.num_pages > 1 %}
        {% bootstrap_pagination lines url="?page=1" size="large" %}
    {% endif %}
{% endblock %}

templates/qa/question.html
{% extends 'base.html' %}
{% load bootstrap5 %}
{% load static %}

{% block title %}
    {% if question.is_answered %}
        Вопрос (решён):
    {% else %}
        Вопрос:
    {% endif %}
    "{{ question.title }}"
{% endblock %}'

{% block content %}
    {% if not user.is_authenticated %}
        <svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
          <symbol id="info-fill" fill="currentColor" viewBox="0 0 16 16">
            <path d="M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zm.93-9.412-1 4.705c-.07.34.029.533.304.533.194 0 .487-.07.686-.246l-.088.416c-.287.346-.92.598-1.465.598-.703 0-1.002-.422-.808-1.319l.738-3.468c.064-.293.006-.399-.287-.47l-.451-.081.082-.381 2.29-.287zM8 5.5a1 1 0 1 1 0-2 1 1 0 0 1 0 2z"/>
          </symbol>
        </svg>
        <div class="alert alert-warning alert-dismissible fade show" role="alert">
            <svg class="bi flex-shrink-0 me-2" width="24" height="24" role="img" aria-label="Info:"><use xlink:href="#info-fill"/></svg>
            Чтобы проголосовать или ответить на вопрос, выполните <a href="/user/login">вход</a>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    {% endif %}

    {# форма голосования #}
    <form id="vote_question" action="#">
        <input type="hidden" id="question" name="question" />
        {% csrf_token %}
    </form>
    <form id="vote_answer" action="#">
        <input type="hidden" id="answer" name="answer" />
        {% csrf_token %}
    </form>

    <div class="d-flex py-3">
        <div class="card d-flex flex-column w-100">
            <div class="card-header{% if question.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                <div class="row">
                    <div class="col">
                        {% if user.profile.avatar %}
                            <img src="{{ question.user.profile.avatar.url }}" width="48" height="48" class="rounded-circle me-3" alt="{{ question.user.username }}">
                        {% else %}
                            <img src="/files/avatar.svg" width="48" height="48" class="rounded-circle me-3" alt="{{ question.user.username }}">
                        {% endif %}
                        <span class="fs-7"><span class="badge bg-secondary rounded-pill">{{ question.user }}</span></span>
                    </div>
                    <div class="col text-end">
                        {% for tag in question.tags.all %}
                            <a href="/qa/?search=tag:{{ tag }}" class="badge bg-secondary rounded-pill link-light">{{ tag }}</a>
                        {% endfor %}
                    </div>
                </div>
            </div>
            <div class="card-body">
                <span class="text-start fs-3" style="white-space: pre-line">{{ question.text }}</span>
            </div>
            <div class="card-footer">
                <div class="row">
                    <div class="col">
                        <small class="fs-7 text-small">Создан:  <span class="badge bg-secondary rounded-pill">{{ question.created }}</span></small>
                    </div>
                    <div class="col text-end">
                        <small class="fs-7">Обновлён: <span class="badge bg-secondary rounded-pill">{{ question.updated }}</span></small>
                    </div>
                </div>
            </div>
        </div>
        {% if user.is_authenticated %}
            <div class="d-flex flex-column px-2" style="width: 120px;">
                <button class="btn btn-outline-secondary" onclick="vote_question({{ question.id }}, '1')">+</button>
                <b id="question_score" class="fs-3 text-center">{{ question.score }}</b>
                <button class="btn btn-outline-secondary" onclick="vote_question({{ question.id }}, '-1')">-</button>
            </div>
        {% endif %}
    </div>
    {% if lines %}
        <span class="text-start fs-3 py-3">Ответы на вопрос</span>
        {% for answer in lines %}
            <div class="d-flex py-3">
                <div class="card d-flex lex-column w-100">
                    <div class="card-header{% if answer.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                        <div class="row">
                            <div class="col">
                                {% if answer.user.profile.avatar %}
                                    <img src="{{ answer.user.profile.avatar.url }}" width="48" height="48" class="rounded-circle me-3" alt="{{ answer.user.username }}">
                                {% else %}
                                    <img src="/files/avatar.svg" width="48" height="48" class="rounded-circle me-3" alt="{{ answer.user.username }}">
                                {% endif %}
                                <b>{{ answer.user }}</b>
                            </div>
                            <div class="col text-end">{{ answer.created }}</div>
                        </div>
                    </div>
                    <div class="card-body">
                        <span class="card-text" style="white-space: pre-line">{{ answer.text }}</span>
                    </div>
                    {% if answer.is_answered %}
                        <div class="card-footer bg-success bg-gradient opacity-75">Автор вопроса отметил этот ответ правильным</div>
                    {% endif %}
                </div>
                {% if user.is_authenticated %}
                    <div class="d-flex flex-column px-3" style="width: 80px;">
                        <button class="btn btn-outline-secondary" onclick="vote_answer({{ answer.id }}, '1')">+</button>
                        <b id="answer_{{ answer.id }}_score" class="fs-5 text-center">{{ answer.score }}</b>
                        <button class="btn btn-outline-secondary" onclick="vote_answer({{ answer.id }}, '-1')">-</button>
                    </div>
                {% endif %}
            </div>
            {% if not question.is_answered and user.id == question.user_id %}
                <a class="btn btn-outline-secondary" href="{% url 'qa:correct_answer' answer.id %}">Отметить этот ответ как правильный</a>
            {% endif %}
        {% endfor %}
    {% else %}
        <span class="text-start fs-3 py-3">Ответов пока что нет. Есть что ответить?</span>
    {% endif %}

    {% if lines.paginator.num_pages > 1 %}
        {% bootstrap_pagination lines url="?page=1" size="large" %}
    {% endif %}

    {% if user.is_authenticated %}
        <div class='py-3'>
            <form method="POST">
                {% csrf_token %}
                {% bootstrap_form form %}
                <button class="btn btn-primary" type="submit">Создать</button>
            </form>
        </div>
    {% endif %}

    <script src="{% static 'js/script.js' %}"></script>
{% endblock %}

templates/qa/search.html
{% extends 'base.html' %}
{% load bootstrap5 %}

{% block title %}
    Результаты поиска
{% endblock %}'

{% block content %}
    {% if lines %}
        {% for question in lines %}
            <div class="d-flex py-3">
                <div class="card d-flex flex-column w-100">
                    <div class="card-header{% if question.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                        <div class="row">
                            <div class="col">
                                <span class="fs-7"><span class="badge bg-secondary rounded-pill">{{ question.user }}</span></span>
                            </div>
                            <div class="col text-end">
                                <small class="fs-7">Создан:  <span class="badge bg-secondary rounded-pill">{{ question.created }}</span></small>
                            </div>
                        </div>
                    </div>
                    <div class="card-body d-flex">
                        <div class="d-flex flex-column w-100">
                            <a href="{% url 'qa:question' question_id=question.id %}" class="fs-5">
                                {{ question.title }}
                            </a>
                            {% if question.is_answered %}(для этого вопроса указано решение){% endif %}
                        </div>
                        <div class="d-flex flex-column text-center" style="width: 120px">
                            <b class="fs-3">{{ question.score }}</b>
                        </div>
                    </div>
                </div>
            </div>
        {% endfor %}
    {% else %}
        <span class="fs-3">По запросу "{{ request.GET.search }}" ничего не найдено</span>
    {% endif %}
    {% if lines.paginator.num_pages > 1 %}
        {% bootstrap_pagination lines url="?page=1" size="large" %}
    {% endif %}
{% endblock %}